/*************************************************************************
  T/SDAS-AD1/14/300K-DA1/16/300K rev.2A SIOX AD/DA DCM definitions 
  for C3x/C6x DSP. Rev.2A
  (C) MicroLAB Systems Ltd, 1993-2001

  Notes:
    1. This file must be used as .H header file for 32-bit
       C3x/C6x DSP environments of host TORNADO DSP system or
       controller.

*************************************************************************/
#ifndef __SXADDA1_DEF__
#define __SXADDA1_DEF__		1


//======================== general definitions ===========================

#define	TSDAS_ADDA1_OFF		0
#define	TSDAS_ADDA1_ON		1
//========================================================================


//======================== Host Commands =================================

	//---- DAC write command	
#define	TSDAS_ADDA1_DAC_WR_CMND				0x20000000L

	//---- CONTROL RG (Fs MUX) command
#define	TSDAS_ADDA1_CNTR_RG_WR_CMND			0x40000000L

	//---- PFG load command
#define	TSDAS_ADDA1_PFG_WR_CMND				0x60000000L

	//---- ADC ENABLE command
#define	TSDAS_ADDA1_ADC_EN_CMND				0x80000000L
#define	TSDAS_ADDA1_ADC_EN_SHIFT			31

//========================================================================


//=================== peripherals definitions ============================

	//------- DAC data field
#define TSDAS_ADDA1_DAC_DATA_BITMASK		0x0000ffffL

	//------- DAC data field
#define TSDAS_ADDA1_ADC_DATA_BITMASK		0x0000fffcL
#define TSDAS_ADDA1_ADC_DATA_SHIFT			2

	//---- Fs SELECTOR field in CONTROL RG
#define	TSDAS_ADDA1_FSSEL_BITMASK			0x00000000L
#define	TSDAS_ADDA1_FSSEL_PFG				0x00000000L
#define	TSDAS_ADDA1_FSSEL_XTIMER			0x00000001L
#define	TSDAS_ADDA1_FSSEL_XFS				0x00000002L


	//---- PFG defs
	//     PFG_out=(10.0MHz*N*V)/(M*R*X*Z)
#define TSDAS_ADDA1_PFG_REF_CLK_FREQ		10.0e+6		// PFG reference frequency is 10.0MHz
#define TSDAS_ADDA1_PFG_DATA_BITMASK		0x03ffffffL

		//note: PFG N/M fields data shall be bit-reversed !!!
#define TSDAS_ADDA1_PFG_N_BITMASK			0x00fe0000L
#define TSDAS_ADDA1_PFG_M_BITMASK			0x0001fc00L
#define TSDAS_ADDA1_PFG_V_BITMASK			0x00000200L
#define TSDAS_ADDA1_PFG_X_BITMASK			0x00000180L
#define TSDAS_ADDA1_PFG_R_BITMASK			0x00000060L
#define TSDAS_ADDA1_PFG_CNF_DATA			0x0000000dL	//- to be ORed for proper operation
#define	TSDAS_ADDA1_PFG_Z_BITMASK			0x03000000L

#define TSDAS_ADDA1_PFG_N_SHIFT				17
#define TSDAS_ADDA1_PFG_M_SHIFT				10
#define TSDAS_ADDA1_PFG_V_SHIFT				9
#define TSDAS_ADDA1_PFG_X_SHIFT				7
#define TSDAS_ADDA1_PFG_R_SHIFT				5
#define TSDAS_ADDA1_PFG_Z_SHIFT				24

		// V-field def
#define	TSDAS_ADDA1_PFG_V_X1				0		//x1 output mutiplier
#define	TSDAS_ADDA1_PFG_V_X8				1		//x8 output mutiplier

		// X-field def
#define	TSDAS_ADDA1_PFG_X_DIV1				0		//:1 output divider
#define	TSDAS_ADDA1_PFG_X_DIV2				2		//:2 output divider
#define	TSDAS_ADDA1_PFG_X_DIV4				1		//:4 output divider
#define	TSDAS_ADDA1_PFG_X_DIV8				3		//:8 output divider

		// R-field def
#define	TSDAS_ADDA1_PFG_R_DIV1				0		//:1 output divider
#define	TSDAS_ADDA1_PFG_R_DIV2				2		//:2 output divider
#define	TSDAS_ADDA1_PFG_R_DIV4				1		//:4 output divider
#define	TSDAS_ADDA1_PFG_R_DIV8				3		//:8 output divider

		// Z-field def
#define	TSDAS_ADDA1_PFG_Z_DIV256			0		//:256 output divider
#define	TSDAS_ADDA1_PFG_Z_DIV2048			1		//:2048 output divider
#define	TSDAS_ADDA1_PFG_Z_DIV16384			2		//:16384 output divider


		// macros for direct generation of PFG load command word (ADC READ command is not provided)
		// note!!!: n/m fields shall be in the bit-reversed code
#define	TSDAS_ADDA1_pfg_cmnd_direct(n,m,v,x,r,z)	(  TSDAS_ADDA1_PFG_WR_CMND\
									 		 | ((n<<TSDAS_ADDA1_PFG_N_SHIFT) & TSDAS_ADDA1_PFG_N_BITMASK) \
				       	  					 | ((m<<TSDAS_ADDA1_PFG_M_SHIFT) & TSDAS_ADDA1_PFG_M_BITMASK) \
										     | ((v<<TSDAS_ADDA1_PFG_V_SHIFT) & TSDAS_ADDA1_PFG_V_BITMASK) \
								  			 | ((x<<TSDAS_ADDA1_PFG_X_SHIFT) & TSDAS_ADDA1_PFG_X_BITMASK) \
					  						 | ((r<<TSDAS_ADDA1_PFG_R_SHIFT) & TSDAS_ADDA1_PFG_R_BITMASK) \
					  						 | ((z<<TSDAS_ADDA1_PFG_Z_SHIFT) & TSDAS_ADDA1_PFG_Z_BITMASK) \
					  						 | TSDAS_ADDA1_PFG_CNF_DATA)
//=====================================================================



//=============== SIO port configuration ==============================
// recommended configuration for C3x DSP:
//	ASYNC-MODE:
//       XLen=32bits, RLen=16bits
//       XCLK/RCLK - Ext
//       FSX - output (1), HS=0, XVAREN=RVAREN=0, XFSM=RFSM=0
//       CLKXP/CLKRP - active high,
//       FSXP=FSRP - active low (1)
//	SYNC-MODE:
//       XLen=32bits, RLen=16bits
//       XCLK/RCLK - Ext
//       FSX - input, HS=0, XVAREN=RVAREN=0, XFSM=RFSM=0
//       CLKXP/CLKRP - active high,
//       FSXP=FSRP - active low (1)
// GCR-ASYNC_MODE: 0000 0000 0001 1111 0000 0000 0000 0100
// GCR-SYNC_MODE:  0000 0000 1001 0111 0000 0000 0000 0000

#define	TSDAS_ADDA1_C3X_SIO_GCRG_DATA_ASYNC		0x001F0004
#define	TSDAS_ADDA1_C3X_SIO_GCRG_DATA_SYNC		0x00170000

#define	TSDAS_ADDA1_C3X_SIO_GCRG_GO_MASK		0x0c000000	// enable R/X
#define	TSDAS_ADDA1_C3X_SIO_GCRG_RINT_MASK		0x02000000	// RINT 
#define	TSDAS_ADDA1_C3X_SIO_GCRG_RTINT_MASK		0x01000000	// RTINT
#define	TSDAS_ADDA1_C3X_SIO_GCRG_XINT_MASK		0x00800000	// XINT
#define	TSDAS_ADDA1_C3X_SIO_GCRG_XTINT_MASK		0x00400000	// XTINT

#define	TSDAS_ADDA1_C3X_SIO_XCRG_DATA			0x111
#define	TSDAS_ADDA1_C3X_SIO_RCRG_DATA			0x111

#define TSDAS_ADDA1_C3X_SIO_RXTCRG_DATA			0		// can be ignored
#define TSDAS_ADDA1_C3X_SIO_RXTPERRG_DATA		0		// can be ignored


// recommended configuration for C6x DSP:
//	ASYNC-MODE:
//       XLen=32bits, RLen=16bits
//       XCLK/RCLK - Ext
//       FSX - output on DX load event, FSR - ext
//       CLKXP/CLKRP - active high,
//       FSXP=FSRP - active low (1)
//	SYNC-MODE:
//       XLen=32bits, RLen=16bits
//       XCLK/RCLK - Ext
//       FSX/FSR - ext
//       CLKXP/CLKRP - active high,
//       FSXP=FSRP - active low (1)
// SPCR:       0000 0000 0000 0000 0000 0000 0000 0000
// PCR-ASYNC:  0000 0000 0000 0000 0000 1000 0000 1100
// PCR-SYNC:   0000 0000 0000 0000 0000 0000 0000 1100
// XCR-ASYNC:  0000 0000 0000 0001 0000 0000 1010 0000
// XCR-SYNC:   0000 0000 0000 0001 0000 0000 0100 0000
// RCR-ASYNC:  0000 0000 0000 0001 0000 0000 0100 0000
// RCR-SYNC:   0000 0000 0000 0001 0000 0000 0100 0000
// SRGR: 	   0010 0000 0000 0000 0000 0000 0000 0000

#define	TSDAS_ADDA1_C6X_MCBSP_SPCR_DATA			0x00000000L
#define	TSDAS_ADDA1_C6X_MCBSP_PCR_DATA_ASYNC	0x0000080cL
#define	TSDAS_ADDA1_C6X_MCBSP_PCR_DATA_SYNC		0x0000000cL
#define	TSDAS_ADDA1_C6X_MCBSP_XCR_DATA_ASYNC	0x000100a0L
#define	TSDAS_ADDA1_C6X_MCBSP_XCR_DATA_SYNC		0x00010040L
#define	TSDAS_ADDA1_C6X_MCBSP_RCR_DATA_ASYNC	0x00010040L
#define	TSDAS_ADDA1_C6X_MCBSP_RCR_DATA_SYNC		0x00010040L
#define	TSDAS_ADDA1_C6201_MCBSP_SRGR_DATA		0x20000000L

#define	TSDAS_ADDA1_C6X_MCBSP_SPCR_GO_MASK		0x00010001L	// mask for remove RST/XRST bits

//=====================================================================



//===================== Extended API ==================================
// Extended API functions include utility functions fro DCM control. However, 
// in order to reduce the size of DSP code or to exclude mutiple function body 
// appearance, extended API functions can be included/excluded during the 
// compilation process for different .C modules in user application. 
// Inclusion/exclusion of Extended API function is controlled via global 
// variables, which shall be defined in parent .C user code:
//
//	__TSDAS_ADDA1_EXCLUDE_XAPI__
//		- if defined in user code, then extended API functions are excluded
//		  from the user source code. Default is INCLUDED.

//------------- Extended API functions declarations -------------------
// These functions/macros can be used from all .C code modules in user 
// applications.

	// bit reversal function for PFG n/m data fields
unsigned _TSDAS_ADDA1_reverse_bits(unsigned x, unsigned nb);

	// macros for generation of PFG command word with bith reversed fields
#define	TSDAS_ADDA1_pfg_cmnd(n,m,v,x,r,z)	TSDAS_ADDA1_pfg_cmnd_direct(\
												_TSDAS_ADDA1_reverse_bits(n,7),\
												_TSDAS_ADDA1_reverse_bits(m,7),\
												v,x,r,z)
//---------------------------------------------------------------------


//---------------- Extended API functions -----------------------------
#ifndef __TSDAS_ADDA1_EXCLUDE_XAPI__

unsigned _TSDAS_ADDA1_reverse_bits(unsigned x, unsigned nb)
	// This procedure is used for PFG data processing and reverses bits 
	// inside the 16-bit X-word for correct load to the PFG data word.
	// Number of reversed bits is defined by NB var.
{ unsigned xr,mask,i;

  for(i=nb,mask=0x1,xr=0;i>0;i--)
   { if((x&mask)!=0)  xr |=0x1;	
     if(i>1) xr <<=1;		
     mask <<=1;
   }
   return(xr);
}


#endif	// end of XAPI
//===========================================================================


#endif	// end of SX-ADDA1 defs
